<template>
	<a-card :bordered="false">
		<a-form ref="searchFormRef" name="advanced_search" :model="searchFormState" class="ant-advanced-search-form">
			<a-row :gutter="24">
				<a-col :span="6">
					<a-form-item label="供货商名称" name="searchKey">
						<a-input v-model:value="searchFormState.searchKey" placeholder="请输入供货商名称" />
					</a-form-item>
				</a-col>
				<a-col :span="6">
					<a-form-item label="联系方式" name="searchKey">
						<a-input v-model:value="searchFormState.searchKey" placeholder="请输入联系方式" />
					</a-form-item>
				</a-col>
				<a-col :span="6">
					<a-button type="primary" @click="tableRef.refresh()">查询</a-button>
					<a-button style="margin: 0 8px" @click="reset">重置</a-button>

					<a-button type="primary" @click="formRef.onOpen()" v-if="hasPerm('supplierAdd')">
						<template #icon><plus-outlined /></template>
						新增
					</a-button>
				</a-col>
			</a-row>
		</a-form>
		<s-table
			ref="tableRef"
			:columns="columns"
			:data="loadData"
			bordered
			:row-key="(record) => record.id"
		>
			<template #bodyCell="{ column, record, index }">
				<template v-if="column.dataIndex === 'serial'">
					{{ index + 1 }}
				</template>
				<template v-if="column.dataIndex === 'action'">
					<a-space>
						<a @click="formRef.onOpen(record)" v-if="hasPerm('supplierEdit')">编辑</a>
						<a-divider type="vertical" v-if="hasPerm(['supplierEdit', 'supplierDelete'], 'and')" />
						<a-button type="link" danger size="small" v-if="hasPerm('supplierDelete')" @click="deleteConfig(record)">删除</a-button>
					</a-space>
				</template>
			</template>
		</s-table>
	</a-card>
	<Form ref="formRef" @successful="tableRef.refresh()" />
</template>

<script setup name="bizsupplier">
	import { cloneDeep } from 'lodash-es'
	import Form from './form.vue'
	import supplierApi from '@/api/biz/supplierApi'
	import {ExclamationCircleOutlined} from '@ant-design/icons-vue';
	import {Modal} from 'ant-design-vue';
	import {createVNode} from 'vue';

	const searchFormState = ref({})
	const searchFormRef = ref()
	const tableRef = ref()
	const formRef = ref()
	const submitLoading = ref(false)
	const toolConfig = { refresh: true, height: true, columnSetting: true, striped: false }
	const columns = [
		{
			title: '序号',
			width: 50,
			dataIndex: 'serial',
			align:'center'
		},
		{
			title: '供货商名称',
			width: 250,
			dataIndex: 'supplierName',
			align:'center'
		},
		{
			title: '供货商地址',
			dataIndex: 'supplierAddress',
			align:'center'
		},
		{
			title: '联系人',
			width: 180,
			dataIndex: 'supplierContactName',
			align:'center'
		},
		{
			title: '手机号',
			width: 180,
			dataIndex: 'supplierPhone',
			align:'center'
		},
	]
	// 操作栏通过权限判断是否显示
	columns.push({
		title: '操作',
		dataIndex: 'action',
		align: 'center',
		width: 150
	})

	const selectedRowKeys = ref([])
	// 列表选择配置
	const options = {
		// columns数字类型字段加入 needTotal: true 可以勾选自动算账
		alert: {
			show: true,
			clear: () => {
				selectedRowKeys.value = ref([])
			}
		},
		rowSelection: {
			onChange: (selectedRowKey, selectedRows) => {
				selectedRowKeys.value = selectedRowKey
			}
		}
	}
	const loadData = (parameter) => {
		const searchFormParam = cloneDeep(searchFormState.value)
		return supplierApi.supplierPage(Object.assign(parameter, searchFormParam)).then((data) => {
			return data
		})
	}
	// 重置
	const reset = () => {
		searchFormRef.value.resetFields()
		tableRef.value.refresh(true)
	}
	// 删除
	const deleteConfig = (record) => {

		Modal.confirm({
			title: '确定删除该数据吗？',
			icon: createVNode(ExclamationCircleOutlined),
			content: '',
			onOk() {
				submitLoading.value = true
				let params = [
					{
						id: record.id
					}
				]

				supplierApi
					.supplierDelete(params)
					.then(() => {
						tableRef.value.refresh(true)
					})
					.finally(() => {
						submitLoading.value = false
					})
			},
			onCancel() {}
		})
	}
</script>
